*
* main.s
*
* v0.11 28/06/01
*
* resolves domain names into IP addresses
*

ASSEMBLE
	CON(1)		8
RPL
xNAME RESOLV
::
 CK1&Dispatch
  real	xR>B
  str	::
	  { HXS 10 5300000000000000 }
	  xIFERR
	  ::
	   TAG & ID DNS xRCL
	   xIF
	   ::
	    xDUP xTYPE %10 x#?
	   ;
	   xTHEN
	   ::
	    $ "" xDOERR
	   ;
	   xIFEND
	  ;
	  xERRTHEN
	  ::
	   %2 xDROPN
	   $ "Please set DNS" xDOERR
	  ;
	  xIFEND

	  x+ %0 x+ xBIND AtUserStack
	  Rclpar
	CODE
	GOSUBL	saveregs

	A=DAT1	A
	?A#0	A
	GOYES	+

stringexp
	LC(5)	XErr_Stringexp
	GOSBVL	=GETPTR
	GOVLNG	=Errjmp

+
	D0=A	A
	A=DAT0	A
	LC(5)	=DOCSTR
	?A#C	A
	GOYES	stringexp

	D0=D0+	5
	A=DAT0	A
	A=A-CON	A,5

	?A=0	A
	GOYES	stringexp

	D0=D0+	5
	CD0EX
	R2=A.F	A
	R1=C.F	A

	LC(5)	10+(4+4+4*4)+(2*4)+4	header + #n + qname + #0 + QTYPE & QCLASS

	C=C+A	A

	R3=C.F	A

	GOSBVL	=GETTEMP

	CD0EX
	RSTK=C
	D0=C	A

	LC(5)	=DOCSTR
	DAT0=C	A
	D0=D0+	5

	C=R3.F	A
	C=C-CON	A,5
	DAT0=C	A
	D0=D0+	5

	D1=(5)	=CRC

* identifier

	A=DAT1	4
	DAT0=A	4
	D0=D0+	4
	B=A	A

	A=R4.F	A
	LC(5)	(dnsquery)-(sauvegardes)
	A=A+C	A
	D1=A	A

* records it
	A=B	A
	DAT1=A	4


* flags
	LC(4)	#1			standard query, recursive please
	DAT0=C	4
	D0=D0+	4

* number of questions, answers, authority record, additional record.
	LC(4)	#100
	DAT0=C	4
	D0=D0+	4

	C=0	W
	DAT0=C	12
	D0=D0+	12

	C=R1.F	A
	D1=C	A
	C=R2.F	A
	D=C	A

* the QNAME
	GOSUB	name

	C=0	B
	DAT0=C	2			final #0
	D0=D0+	2

* and the TYPE and CLASS of QNAME
	LC(4)	_dns_TYPE_A
	DAT0=C	4
	D0=D0+	4

	LC(4)	_dns_CLASS_IN
	DAT0=C	4

* now push it instead of the name
	GOSBVL	=GETPTR
	C=RSTK
	DAT1=C	A

fullm
	GOSBVL	=SAVPTR
	GOVLNG	=GETPTRLOOP
ENDCODE

	  xWRITE HXS 10 0 xNEWOB
	  xREAD
	  AtUserStack
	  Rclpar
CODE
	GOSUBL	saveregs

	A=DAT1	A
	D1=A	A		on the string
	D1=D1+	5

	C=DAT1	A		size (nibbles)
	D=C	A
	D1=D1+	5
	D=D-CON A,5

	A=R4.F	A
	LC(5)	(dnsquery)-(sauvegardes)
	A=A+C	A
	D0=A	A

	A=C	A
	A=DAT0	4
	C=DAT1	4
	D1=D1+	4
	D=D-CON	A,4
	GOC	resolverr

	?A=C	A
	GOYES	+
resolverr
	LA(5)	XErr_Resolv
	GOTOL	erreur

+
	C=DAT1	2
	D1=D1+	2
	D=D-CON	A,2
	GOC	resolverr

* really an answer ?
	?CBIT=0	_b_dns_QR
	GOYES	resolverr

	C=DAT1	2
	D1=D1+	2
	D=D-CON	A,2
	GOC	resolverr
	?C#0	P
	GOYES	resolverr

* number of questions
	GOSUB	read16D1C

	R0=C.F	A

* number of answers
	GOSUB	read16D1C

	R1=C.F	A

* number of authority records
	GOSUB	read16D1C

	R2=C.F	A

* number of additional records
	GOSUB	read16D1C

	R3=C.F	A

	C=R0.F	A
	B=C	A
	C=0	A
Questions
	B=B-1	A
	GOC	Answers
-
	C=DAT1	B
	D1=D1+	2
	D=D-CON	A,2
	GOC	resolverr

	?C=0	B		end ?
	GOYES	QuestTYPE

	C=C+C	B		-> nibbles
	AD1EX	A
	A=A+C	A
	D1=A	A

	GOTO	-

QuestTYPE			and class
	D1=D1+	8
	D=D-CON	A,8
	GONC	+
	GOTO	resolverr
+

	GOTO	Questions


Answers
	ST=0	_b_st_RESOLV
	C=R1.F	A
	B=C	A
	C=0	A
Answer
	B=B-1	A
	GONC	+
	GOTO	Authorities
+
	D1=D1+	4
	D=D-CON	A,4
	GONC	+
	GOTO	resolverr
+
	A=DAT1	4
	D1=D1+	4
	D=D-CON	A,4
	GONC	+
	GOTO	resolverr
+
	C=A	A
	LC(4)	_dns_TYPE_A
	?C#A	A
	GOYES	+
	ST=1	_b_st_RESOLV
+
	A=DAT1	4
	D1=D1+	4
	D=D-CON	A,4
	GONC	+
	GOTO	resolverr
+
	LC(4)	_dns_CLASS_IN
	?C=A	B
	GOYES	+
	GOTO	resolverr
+
	D=D-CON	A,12
	GONC	+
	GOTO	resolverr
+
	D1=D1+	8
	A=0	A
	A=DAT1	2
	ASL	A
	ASL	A
	D1=D1+	2
	A=DAT1	2
	D1=D1+	2
	A=A+A	A	->nibbles

	?ST=1	_b_st_RESOLV
	GOYES	resolvIP

	CD1EX
	C=C+A	A
	D1=C	A
	CDEX	A
	C=C-A	A
	CDEX	A
	GONC	+
	GOTO	resolverr
+
	GOTO	Answer


resolvIP
	LC(5)	8
	?C=A	A
	GOYES	+
	GOTO	resolverr
+
	D=D-CON	A,8
	GONC	+
	GOTO	resolverr
+
* here we are !
* let's note this adress down

	CD1EX	A
	R0=C.F	A

	GOSBVL	=GETPTR

	D1=D1+	5
	D=D+1	A		drops the string

	GOSBVL	=SAVPTR

	A=DAT1	A
	D1=A	A		on the BINT
	D1=D1+	10+8-2		on hi byte

	C=R0.F	A
	D0=C	A

	P=	3
-
	C=DAT0	B
	D0=D0+	2
	DAT1=C	B
	D1=D1-	2
	P=P-1
	GONC	-

	P=	0

	GOSBVL	=GETPTRLOOP

Authorities
	GOTO	resolverr
ENDCODE
	;
  hxs :: ;
;


ASSEMBLE
read16D1C
	D=D-CON	A,4
	GONC	+
	GOTO	resolverr
+
	C=0	A
	C=DAT1	2
	D1=D1+	2
	CSL	A
	CSL	A
	C=DAT1	2
	D1=D1+	2
	RTN
RPL
